
#xcommand TREEDUCER                   ;
                <cFile>               ;
                [FRAME  <nFrame>]     ;
                [<gg: GREENBAR>]      ;
                [<ng: NOGREENBAR>]    ;
                [DUPLEX <nDuplex>]    ;
                [COPIES <nCopies>]    ;
                [TRAY   <nTray>]      ;
                [<ww: WRAP>]          ;
                [<nw: NOWRAP>]        ;
                [<ee: ECODES>]        ;
                [<ne: NOECODES>]      ;
                [TITLE   <bTitle>]    ;
                [DISPLAY <bDisplay>]  ;
                [ERRTRAP <bTrap>]     ;
                [COLUMNS <nColumns>]  ;
                [TABSIZE <nTabsize>]  ;
		[MINI    <nMini>]     ;
                [LINENUM <nLStyle>]   ;
                                      ;
                                      ;
                                      ;
        =>  TreeDuce(  <cFile>        ;
                ,[<nFrame>]           ;
                ,[<.gg.>][!<.ng.>]    ;
                ,[<nDuplex>]          ;
                ,[<nCopies>]          ;
                ,[<nTray>]            ;
                ,[<.ww.>][!<.nw.>]    ;
                ,[<.ee.>][!<.ne.>]    ;
                ,[<bTitle>]           ;
                ,[<bDisplay>]         ;
                ,[<bTrap>]            ;
                ,[<nColumns>]         ;
                ,[<nTabsize>]         ;
		,[<nMini>]            ;
		,[<nLStyle>]	      ;
             )



// Misc

#command DEFAULT <Var> TO <xVal> [, <Var2> TO <xVal2> ];
      => Iif( <Var> == nil, <Var> := <xVal> , nil) [; Iif( <Var2> == nil, <Var2> := <xVal2>, nil)]

//
// The LJ_???????? definitions are simply Laserjet functions that we've
// defined here to simplify their use.
//
// The TS_???????? definitions are manifest constants for various
// Treeducer parameters.


// Fonts
#define LJ_CONDENSED         "(10U(s0p16.67h8v0s0b0T"
#define LJ_NORMAL            "(10U(s0p10h12v0s0b3T"

//
// JOB CONTROL COMMANDS
//

  #define LJ_PRINTER_RESET     "E"


  // simplex/duplex print
  #define LJ_SIMPLEX           "&l0S"   // Single sided printing
  #define LJ_DUPLEXLONG        "&l1S"   // Long-Edge Binding
  #define LJ_DUPLEXSHORT       "&l2S"   // Short-Edge Binding


  // page side selection
  #define LJ_NEXTSIDE          "&a0G"
  #define LJ_FRONTSIDE         "&a1G"
  #define LJ_BACKSIDE          "&a2G"

//
// PAGE CONTROL COMMANDS
//

  // paper source
  #define LJ_EJECTPAGE          "&l0H"
  #define LJ_UPPERTRAY          "&l1H"
  #define LJ_MANUALFEED         "&l2H"
  #define LJ_MANUALENVELOPEFEED "&l3H"
  #define LJ_LOWERTRAY          "&l4H"
  #define LJ_ENVELOPEFEEDER     "&l6H"

  // page size
  #define LJ_SIZE_EXECUTIVE     "&l1A"
  #define LJ_SIZE_LETTER        "&l2A"
  #define LJ_SIZE_LEGAL         "&l3A"
  #define LJ_SIZE_A4            "&l26A"

  // page size (envelopes)
  #define LJ_SIZE_MONARC        "&l80A"
  #define LJ_SIZE_COM10         "&l81A"
  #define LJ_SIZE_DL            "&l90A"
  #define LJ_SIZE_C5            "&l91A"


//
// ORIENTATION
//

  // Orientation
  #define LJ_PORTRAIT       "&l0O"
  #define LJ_LANDSCAPE      "&l1O"
  #define LJ_REV_PORTRAIT   "&l2O"
  #define LJ_REV_LANDSCAPE  "&l3O"


//
// MARGINS and TEXT LENGTH
//


  #define LJ_CLR_HMARGINS "9"   // Clear horizontal margins

//
// Perforation skip mode
//
  #define LJ_PERF_OFF "&l0L"
  #define LJ_PERF_ON  "&l1L"




//
// CURSOR POSITIONING
//
  // Use the LJ_Goto(), LJ_GotoDP(), LJ_GotoRC() functions
  // for cursor positioning

  // half line feed
  #define LJ_HALF_LF      "="


//
// End of line termination
//

  #define LJ_LTDEFAULT   "&k0G"  // CR=CR   ; LF=LF   ; FF=FF
  #define LJ_LTONE       "&k1G"  // CR=CR+LF; LF=LF   ; FF=FF
  #define LJ_LTTWO       "&k2G"  // CR=CR   ; LF=CR+LF; FF=CR+FF
  #define LJ_LTTHREE     "&k3G"  // CR=CR+LF; LF=CR+LF; FF=CR+FF

//
// push/pop position
//
  #define LJ_PUSHPOS           "&f0S"
  #define LJ_POPPOS            "&f1S"

//
// Font Management
//
  #define LJ_PRIMARY    Chr(15)  // Character 15 (Shift Out)
  #define LJ_SECONDARY  Chr(14)  // Character 14 (Shift In)



//
// TreeDucer parameters
//

  // frame styles
  #define TS_NOFRAME           0
  #define TS_REGFRAME          1   // obsolete name kept for compatibility
  #define TS_BOXFRAME          1
  #define TS_TFRAME            2
  #define TS_IFRAME            3
  #define TS_LINED             4
  #define TS_LINEDLITE         5

  // tiny font styles
  #define TS_NOMINI            0   // (default) don't use SCTMINIFONT
  #define TS_FORCEMINI66       1   // Force SCTMINIFONT with 66 lines/page
  #define TS_BESTFIT           2   // Let Treeducer decide which font
                                   // will fit best.
  #define TS_FORCEMINI88       3   // Force SCTMINIFONT with 88 lines/page
  #define TS_SQUISH            4   // Force squished version of the
                                   // standard 16.66 condensed font

  // trays
  #define TS_NOTRAY         0      // use default tray
  #define TS_UPPERTRAY      1
  #define TS_LOWERTRAY      2

  // duplex parameters
  #define TS_SINGLESIDED       0   // default
  #define TS_DUPLEXLONGEDGE    1
  #define TS_DUPLEXSHORTEDGE   2
  #define TS_FRONTSIDEONLY     3
  #define TS_BACKSIDEONLY      4

  #define TS_NOCOUNT           0   // don't print line numbers, default.

  // The normal way to count line numbers is based on the CR/LFs found
  // in the input file.  This would let the line numbers correspond with
  // source code line numbers that the compiler and debugger would use.
  // if a line is too long to fit, and wraps, the continuations done by
  // Treeducer would not have a line number.

  #define TS_COUNTFILE         1   // print line numbers for whole file
  #define TS_COUNTPAGE         2   // reset line numbers on each page

  // The WRAP versions of the line counting will assign a line number to
  // each line that is output by Treeducer.  I don't have any practical
  // use for this, but somebody out there probably does.

  #define TS_COUNTFILEWRAP     3   // count wraps as a line number
  #define TS_COUNTPAGEWRAP     4   // obvious

  // Add one of these to the count style to set how it looks
  #define TS_COUNTBLANK      0  // don't print anything
  #define TS_COUNTSHADE      10 // shade where the numbers are printed
  #define TS_COUNTLINE       20 // draw a line to the right of the numbers
  #define TS_COUNTSHADELINE  30 // shade line #s AND draw vertical border


  // these are used by the ts_papersize function to let treeducer
  // know what size paper is being used.
  #define TS_SIZE_LETTER     1  // (Default)
  #define TS_SIZE_LEGAL      2

  #define TS_SIZE_EXECUTIVE  3
  #define TS_SIZE_A4         4
  #define TS_SIZE_COM10      5  // (Envelopes)
  #define TS_SIZE_MONARC     6
  #define TS_SIZE_C5         7
  #define TS_SIZE_DL         8


